/******************************************************************************
*******************************************************************************
*******************************************************************************

    libferris streams
    Copyright (C) 2001-2003 Ben Martin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    For more details see the COPYING file in the root directory of this
    distribution.

    $Id: Shell.hh,v 1.1 2005/07/04 08:16:13 ben Exp $

*******************************************************************************
*******************************************************************************
******************************************************************************/

#ifndef _ALREADY_INCLUDED_LIBFERRISSTREAMS_SHELL_H_
#define _ALREADY_INCLUDED_LIBFERRISSTREAMS_SHELL_H_

#include <FerrisStreams/Exceptions.hh>
#include <FerrisStreams/Streams.hh>

namespace Ferris
{
    namespace Factory
    {
        /**
         * unlink the path and create a new fifo there. Open the fifo
         * for read+write in non blocking mode and return that fd.
         *
         * @param  path Where to put the new fifo
         * @return fd open in read+write mode
         */
        FERRISEXP_API int MakeFIFO( const std::string& path ) throw( CreateFIFO );

        /**
         * unlink the path and create a new fifo there. MAYBE Open the fifo
         * in the given mode and return that fd.
         *
         * @param  path Where to put the new fifo
         * @return if(!should_open) then 0 else fd open in openmode
         */
        FERRISEXP_API int MakeFIFO( const std::string& path,
                                    bool should_open,
                                    int openmode = 0 /* O_RDWR | O_NONBLOCK */ )
            throw( CreateFIFO );
    };
};
#endif
